<?php
/*
 * spider.inc.php
 * @version 1.0.00
 * 
 * if you need, change $DIR_PATH_SPIDER_DATA for your Env.
 */
/* Data Directory Absolute Path force */
//$DIR_PATH_SPIDER_DATA			= '';
/* Base URI force definition */
//$SPIDER_DEFINE_BASE_URI		= '';
/* active page file folder   */
define('DIR_NAME_PAGES', 'pages');

/*
 * Common Process. you need not to edit.
 */
$script_filename	= str_replace( '/', DIRECTORY_SEPARATOR, $_SERVER['SCRIPT_FILENAME'] );
if ( $script_filename == __FILE__ ) {
	header( 'Content-type: text/plain;charset=UTF-8' );
	die( 'You can\'t access this file direct!' );
}

if( !isset( $DIR_PATH_SPIDER_DATA ) || strlen( trim( $DIR_PATH_SPIDER_DATA ) ) == 0 ) {
	define ( "DIR_PATH_SPIDER_DATA",	dirname(dirname( __FILE__ ) ).DIRECTORY_SEPARATOR."DATA" );
} else {
	define ( "DIR_PATH_SPIDER_DATA",	$DIR_PATH_SPIDER_DATA );
}
$request_protocol		= $_SERVER['SERVER_PROTOCOL'];
$request_port			= $_SERVER['SERVER_PORT'];
$request_server_name	= $_SERVER['SERVER_NAME'];
$request_uri			= $_SERVER['REQUEST_URI'];
$document_root			= $_SERVER['DOCUMENT_ROOT'];
$is_ssl					= false;
if( isset($_SERVER['HTTPS']) && preg_match('/[oO][fF][fF]/', $_SERVER['HTTPS'] ) == 0 ) {
	$is_ssl				= true;
}
// ユーザーディレクトリをドキュメントルートにする
if( preg_match('/^\\/\\~[0-9a-zA-Z\\_]+\\//',$request_uri) > 0 ) {
	$user_request_uri	= preg_replace('/^\\/\\~[^\\/]+\\//','/',$_SERVER['PHP_SELF'] );
	$document_root		= str_replace( '/',DIRECTORY_SEPARATOR, dirname($script_filename) );
	$document_root		= str_replace( str_replace( '/',DIRECTORY_SEPARATOR, dirname($user_request_uri) ), '', $document_root );
}
if( isset($SPIDER_DEFINE_BASE_URI) && strlen($SPIDER_DEFINE_BASE_URI) > 0 ) {
	$spider_base_uri		= $SPIDER_DEFINE_BASE_URI;
} else {
	$spider_inc_path		= str_replace( DIRECTORY_SEPARATOR, "/", __FILE__ );
	$spider_base_uri		= dirname(str_replace( $document_root, "", $spider_inc_path ));
	if( preg_match('/^\\/\\~[0-9a-zA-Z\\_]+\\//',$request_uri) > 0 ) {
		// ユーザーディレクトリの場合リクエストURIの一つ目の要素をくっつける
		$dirname_array		= explode('/',$request_uri);
		$spider_base_uri	= '/'.$dirname_array[1].$spider_base_uri;
	}
}
if( !preg_match('/\\/$/', $spider_base_uri ) ) {
	$spider_base_uri	.= '/';
}

$prtcl = "http://";
if( $is_ssl ) {
	$prtcl = "https://";
}
$target_port = "";
if ( $request_port != 80 && $request_port != 443 ) {
	$target_port	= ":" . $request_port;
}
$app_base_url	= $prtcl . $request_server_name . $target_port . $spider_base_uri;
$app_nomal_url	= "http://" . $request_server_name . $target_port . $spider_base_uri;
$app_ssl_url	= "https://" . $request_server_name . $target_port . $spider_base_uri;

define( "APPLICATION_BASE_URL", $app_base_url );
define( "APPLICATION_NML_URL", $app_nomal_url );
define( "APPLICATION_SSL_URL", $app_ssl_url );
$app_base_uri = $spider_base_uri;
if ( !preg_match( '/\\/$/', $app_base_uri ) ) {
	$app_base_uri .= '/';
}
define( "APPLICATION_BASE_URI",  $app_base_uri );
define( "APPLICATION_BASE_PATH", dirname(__FILE__ ) );

require_once( DIR_PATH_SPIDER_DATA . DIRECTORY_SEPARATOR . "spider_main.inc.php" );

?>
